﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prototype
{
    //klasa bazowa dla pamiatek
    abstract class Souvenir
    {

        protected String name;


        public abstract Souvenir copy();
        public abstract String toString();
        public void carveName(String name)
        {
            this.name = name;
        }

    }

    //ciupaga
    class Alpenstock:Souvenir
    {

        int length;


        public Alpenstock()
        {
            Console.WriteLine("Bardzo dlugi i zmudny proces wytwarzania ciupagi");
            this.length = 150;
        }

        public override Souvenir copy()
        {
            //zwykly memberwise clone - w przypadku gdy klasa przechowuje typy referencje (w tym wypadku jest to tylko zwykly int)
            //nalezy zastanowic sie czy nie bedzie potrzebne glebokie kopiowanie (deep copy)
            Console.WriteLine("Klonowanie ciupagi");
            return this.MemberwiseClone() as Souvenir;
        }

        public override string toString()
        {
            return String.Format("Ciupaga dla {0}", this.name);
        }
    }

    //szkatulka
    class Casket : Souvenir
    {

        int width;
        int height;
        int depth;

        public Casket()
        {
            Console.WriteLine("Bardzo dlugi i zmudny proces wytwarzania szkatulki");
            this.width = 50;
            this.height = 30;
            this.depth = 20;
        }


        public override Souvenir copy()
        {
            Console.WriteLine("Klonowanie szkatulki");
            return this.MemberwiseClone() as Souvenir;
        }

        public override string toString()
        {
            return String.Format("Szkatulka dla {0}", this.name);
        }

    }

    //klasa stoiska
    class Stand
    {
        Alpenstock alpenstockPrototype;
        Casket casketPrototype;

        public Stand()
        {
            this.alpenstockPrototype = new Alpenstock();
            this.casketPrototype = new Casket();
        }

        public Souvenir sell(String souvenirType, String name)
        {
            Souvenir result = null;
            if(souvenirType.Equals("alpenstock"))
            {
                result = this.alpenstockPrototype.copy();
            }
            else if(souvenirType.Equals("casket"))
            {
                result = this.casketPrototype.copy();
            }
            else
            {
                throw new ArgumentException("Souvenir not sold");
            }
            //nalezy zauwazyc, ze imie jest wyryte na kopii protypu, efektywnie nasze alpensotckPrototype i casketPrototype nigdy nie ulegaja zmianie
            //jednak dzieki kopiowani unikamy kosztownych konstruktorow, zaslaniamy tez przed klientem klasy alpenstock i casket
            result.carveName(name);
            return result;

        }

    }

    class Program
    {

        static void Main(string[] args)
        {
            Stand myStand = new Stand();
            Souvenir a = myStand.sell("alpenstock", "Daniel");
            Souvenir b = myStand.sell("alpenstock", "Asia");
            Souvenir c = myStand.sell("casket", "Milena");

            Console.WriteLine(a.toString());
            Console.WriteLine(b.toString());
            Console.WriteLine(c.toString());

            Console.ReadKey();
        }
    }
}
